unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, crc32, ComCtrls, dateutils;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1:   TMemo;
    Edit1:   TEdit;
    Label1:  TLabel;
    Button2: TButton;
    pg:      TProgressBar;
    Button3: TButton;
    procedure Button1Click (Sender: TObject);
    procedure Button2Click (Sender: TObject);
    procedure Button3Click (Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

  LogLines: TStringList;


implementation

uses  cartman2ddp1;

{$R *.dfm}


var
  buf: t128buf = (0, 0, 0, 0);

var
  cb: t128buf;

var
  tkey: array [0..31] of longword;

var
  test_count: longint = 2048;

var
  run: boolean = False;


{$R+}


type
  TInt64Array = array [0..1] of int64;

type
  PInt64Array = ^TInt64Array;

procedure LogBuff (s: string);
begin
  LogLines.Append(s);
end;

function HexToInt64 (Hex: string): int64;
var
  i, Data: integer;

begin
  Result := 0;
  for i := 1 to 16 do
    begin
    if byte(Hex[i]) < $3A then
      Data := byte(Hex[i]) - 48
    else
      Data := byte(Hex[i]) - 55;
    Result := 16 * Result + Data;
    end;
  Result := Result;
end;

function Int64ToHex (v: int64): string;
begin
  Result := IntToHex(v, 16);
end;


procedure TForm1.Button1Click (Sender: TObject);
var
  i, n, k: integer;
  error: boolean;
  keytext, datatext: string;
begin

  screen.Cursor := crHourGlass;

  test_count := strtointdef(edit1.Text, 2048);

  memo1.Clear;

  loglines.Clear;

  error := False;


  for i := 0 to test_count - 1 do
    begin

    if i <> test_count - 3 then
      begin

      for n := 0 to 3 do
        buf[n] := random(maxlong);

      end
    else
      begin
      for n := 0 to 3 do
        buf[n] := 0;

      end;


    if i < test_count - 2 then

      for n := 0 to 31 do
        tkey[n] := random(maxlong)

    else

    if i <> test_count - 1 then

      for n := 0 to 31 do
        tkey[n] := 0

    else
      for n := 0 to 31 do
        tkey[n] := $FFFFFFFF;

    LogBuff(#13#10#13#10 + 'KEY: ');

    keytext := '';
    for k := 0 to 31 do
      keytext := keytext + inttohex(tkey[k], 8) + ' ';
    LogBuff(keytext);

    LogBuff('ORIGINAL: ');
    datatext := '';
    for k := 0 to 3 do
      datatext := datatext + inttohex(buf[k], 8) + ' ';
    LogBuff(datatext);


    cartman2_setkey(@tkey);   // Loading then key

    move(buf, cb, 16);
    cartman2_crypt(@cb); // Encryption of 4-longwords (128 bit block)

    cartman2_killkey(); // Burning key

    LogBuff('ENCRYPTED: ');
    datatext := '';
    for k := 0 to 3 do
      datatext := datatext + inttohex(cb[k], 8) + ' ';
    LogBuff(datatext);


    cartman2_setkey(@tkey);   // Loading then key

    cartman2_decrypt(@cb); // Decryption of 4-longwords (64 bit block)

    LogBuff('DECRYPTED: ');
    datatext := '';
    for k := 0 to 3 do
      datatext := datatext + inttohex(cb[k], 8) + ' ';
    LogBuff(datatext);


    if (cb[0] <> buf[0]) or (cb[1] <> buf[1]) or (cb[2] <> buf[2]) or
      (cb[3] <> buf[3]) then
      error := True;

    if error then
      LogBuff('DECODED TO BAD DATA!!!')
    else

      LogBuff('DECODED OK');

    end;


  LogBuff(#13#10#13#10#13#10 + ' ------------------------------  ');

  if error then
    LogBuff('TEST FAILED, DECODED DATA IS BAD.')
  else
    LogBuff(FORMAT('ALL %U TESTS FINISHED OK!', [test_count]));


  memo1.Lines.AddStrings(loglines);
  memo1.SelLength := 1;
  memo1.SelStart  := length(memo1.Text);

  screen.Cursor := crArrow;

end;


function FileSizeByName (const AFilename: string): int64;
begin
  with TFileStream.Create(AFilename, fmOpenRead or fmShareDenyNone) do
      try
      Result := Size;
      finally
      Free;
      end;
end;


procedure pproc (Data: integer);
begin
  form1.pg.Position := form1.pg.Position + Data;
end;


procedure cartmancomp (si, st: string; decrypt: boolean = False; sizeorig: longint = 0);
var
  FileIn, FileOut: TFileStream;
  Buffer:  array [0..15] of byte;
  BlockSize: longword;
  Left, N: longint;

begin

  FileIn := TFileStream.Create(si, fmOpenRead or fmShareDenyWrite);
  FileOut := TFileStream.Create(st, fmCreate);
  Left := FileIn.Size;
  FillChar(Buffer, 16, 0);
  cartman2_setkey(@tkey);

  repeat
    if left < 16 then
      begin
      for n := 0 to 15 do
        buffer[n] := random(256);
      end;

    blocksize := 16;
    FileIn.Read(Buffer, blocksize);
    if decrypt then
      cartman2_decrypt(@Buffer)
    else
      cartman2_crypt(@Buffer);
    pproc(16);
    FileOut.Write(Buffer, blocksize);
    Dec(left, blocksize);
  until left <= 0;

  FileIn.Destroy;
  if decrypt then
    FileOut.Size := sizeorig;
  FileOut.Destroy;

end;


procedure CartmanFileToFile (si, st: string; decrypt: boolean = False;
  sizeorig: longint = 0);
var
  FileIn, FileOut: TFileStream;
  Buffer:  array [0..15] of byte;
  BlockSize: longword;
  Left, N: longint;
begin
  // Setup
  FileIn := TFileStream.Create(si, fmOpenRead or fmShareDenyWrite);
  FileOut := TFileStream.Create(st, fmCreate);
  Left := FileIn.Size;
  FillChar(Buffer, 16, 0);
  cartman2_setkey(@tkey);
  repeat
    // Pad Short Read
    if left < 16 then
      begin
      for n := 0 to 15 do
        begin
        buffer[n] := random(256);
        end;
      end;
    // Read
    blocksize := 16;
    FileIn.Read(Buffer, blocksize);
    // Process
    if decrypt then
      begin
      cartman2_decrypt(@Buffer);
      end
    else
      begin
      cartman2_crypt(@Buffer);
      end;
    // Save
    FileOut.Write(Buffer, blocksize);
    Dec(left, blocksize);
  until left <= 0;
  // Close
  FileIn.Destroy;
  if decrypt then
    FileOut.Size := sizeorig;
  FileOut.Destroy;
end;


function CartmanFileToString (fn: string; NoOfBlocks, Mode: longword): string;
  // Mode=0=DeCrypt, Mode=1=Encrypt, Mode=2=Fetch
var
  FileIn:  TFileStream;
  Buffer:  array [0..1] of int64;
  BlockSize: longword;
  Left, n: longint;
begin
  Result := '';
  FileIn := TFileStream.Create(fn, fmOpenRead or fmShareDenyWrite);
  BlockSize := 16;
  Left := BlockSize * NoOfBlocks;
  FillChar(Buffer, 16, 0);
  cartman2_setkey(@tkey);
  repeat
    // Pad Short Read
    if mode = 1 then
      if (Left < 16) then
        begin
        for n := 0 to 15 do
          begin
          Buffer[n] := Random(256);
          end;
        end;

    FileIn.Read(Buffer, BlockSize);
    // Decrypt
    if Mode = 0 then
      cartman2_decrypt(@Buffer);

    // Encrypt
    if Mode = 1 then
      cartman2_crypt(@Buffer);

    //    if Mode = 2 then   // do nothing

    Result := Result + Int64ToHex(Buffer[0]) + Int64ToHex(Buffer[1]);

    Dec(Left, Blocksize);

  until left <= 0;

  FileIn.Destroy;
  //  Result:= Copy(Result, 1, BlockSize*NoOfBlocks*2);
end;

function CartmanFileHexToString (fn: string; NoOfBlocks, Mode: longword): string;
  // Mode=0=DeCrypt, Mode=1=Encrypt, Mode=2=Fetch
var
  FileIn: TFileStream;
  Buffer: array [0..1] of int64;
  HexStr: array [0..31] of char;
  BlockSize: longword;
  Left: longint;
begin
  Result := '';
  FileIn := TFileStream.Create(fn, fmOpenRead or fmShareDenyWrite);
  BlockSize := 32;
  Left := BlockSize * NoOfBlocks;
  repeat
    FileIn.Read(HexStr, BlockSize);
    Buffer[0] := HexToInt64(Copy(HexStr, 0, 16));
    Buffer[1] := HexToInt64(Copy(HexStr, 17, 16));
    // Decrypt
    if Mode = 0 then
      begin
      cartman2_decrypt(@Buffer);
      end;
    // Encrypt
    if Mode = 1 then
      begin
      cartman2_crypt(@Buffer);
      end;
    if Mode = 2 then
      begin
      // do nothing
      end;
    Result := Result + Int64ToHex(Buffer[0]) + Int64ToHex(Buffer[1]);
    Dec(Left, BlockSize);
  until Left <= 0;
  FileIn.Destroy;
  Result := Copy(Result, 1, BlockSize * NoOfBlocks);
end;

function CartmanHexStringToHexString (hex: string; Mode: integer): string;
  // Mode=0=DeCrypt, Mode=1=Encrypt
var
  Buffer: array [0..1] of int64;
  Left: longint;
begin
  cartman2_setkey(@tkey);
  left := length(hex);
  repeat
    Buffer[0] := HexToInt64(copy(hex, 1, 16));
    Delete(Hex, 1, 16);
    Buffer[1] := HexToInt64(copy(hex, 1, 16));
    Delete(Hex, 1, 16);
    if Mode = 0 then
      begin
      cartman2_decrypt(@Buffer);
      end;
    if Mode = 1 then
      begin
      cartman2_crypt(@Buffer);
      end;
    Result := Result + Int64ToHex(Buffer[0]) + Int64ToHex(Buffer[1]);
    Dec(left, 32);
  until left <= 0;
end;

procedure CartmanStringToFile (hex, fn: string; size: longint; Mode: integer);
var
  FileOut: TFileStream;
  Buffer: array [0..1] of int64;
  Left: longint;
begin
  FileOut := TFileStream.Create(fn, fmCreate);
  cartman2_setkey(@tkey);
  Left := Length(hex);
  repeat
    Buffer[0] := HexToInt64(copy(hex, 1, 16));
    Delete(Hex, 1, 16);
    Buffer[1] := HexToInt64(copy(hex, 1, 16));
    Delete(Hex, 1, 16);
    if Mode = 0 then
      begin
      cartman2_decrypt(@Buffer);
      end;
    if Mode = 1 then
      begin
      cartman2_crypt(@Buffer);
      end;
    FileOut.Write(Buffer, 16);
    Dec(left, 32);
  until left <= 0;

  if mode = 0 then
    FileOut.Size := size; // [!]
  FileOut.Destroy;
end;


procedure TForm1.Button2Click (Sender: TObject);
var
  i: integer;
var
  origRawHexStr, RawHexStr, CookedHexStr, HexStr1, HexStr2: string;
  LineData: TStringList;
begin

  origRawHexStr := '';

  for i := 0 to 16 * 6 - 1 do
    origRawHexStr := origRawHexStr + IntToHex(Random(256), 2);

  RawHexStr := origRawHexStr;


  for i := 0 to 15 do
    tkey[i] := Random(Maxlong);

  ////////////////////////////////////////////////////////////////////////
  // Encrypt
  CartmanStringToFile(RawHexStr, extractfilepath(application.ExeName) + 'test.enc',
    Length(RawHexStr), 1);
  ////////////////////////////////////////////////////////////////////////
  // Decrypt
  RawHexStr := CartmanFileToString(extractfilepath(application.ExeName) +
    'test.enc', 6, 0); // Mode=0=DeCrypt, Mode=1=Encrypt, Mode=2=Fetch
  ////////////////////////////////////////////////////////////////////////
  // Cooked
  CookedHexStr := CartmanFileToString(extractfilepath(application.ExeName) +
    'test.enc', 6, 2); // Mode=0=DeCrypt, Mode=1=Encrypt, Mode=2=Fetch
  LineData  := TStringList.Create;
  LineData.Add(CookedHexStr);
  LineData.SaveToFile(extractfilepath(application.ExeName) + 'test.hex');
  LineData.Free;
  ////////////////////////////////////////////////////////////////////////
  // Test 1
  HexStr1 := CartmanHexStringToHexString(CookedHexStr, 0);

  ////////////////////////////////////////////////////////////////////////
  // Test 2
  HexStr2 := CartmanFileHexToString(extractfilepath(application.ExeName) +
    'test.hex', 6, 0); // Mode=0=DeCrypt, Mode=1=Encrypt, Mode=2=Fetch

  memo1.Clear;
  memo1.Lines.Add('Original: ' + origRawHexStr);
  memo1.Lines.Add('Decrypted1: ' + HexStr1);
  memo1.Lines.Add('Decrypted2:' + HexStr2);

  if (origRawHexStr = HexStr1) and (origRawHexStr = HexStr2) then
    ShowMessage('All the HEX tests OK!')
  else
    ShowMessage('HEX tests FAILED!!!');

end;

procedure TForm1.Button3Click (Sender: TObject);
var
  i, k:  integer;
  d1, d2: tdatetime;
  error: boolean;

begin

  screen.Cursor := crHourGlass;


  memo1.Clear;

  loglines.Clear;

  error := False;

  for I := 0 to 31 do
    tkey[i] := random(maxlong);


  cartman2_setkey(@tkey);
  for i := 0 to 3 do
    buf[i] := random(maxlong);

  move(buf, cb, 16);
  d1 := now;
  for I := 0 to 262143 do
    cartman2_crypt(@cb);
  d2 := now;
  k  := dateutils.MilliSecondsBetween(d1, d2);
  memo1.Lines.Add(Format('Speed:  %.2f  k/bytes per second',
    [(((262144 * 16) / k) * 1000) / 1024]));
  screen.Cursor := crArrow;

end;

initialization


  randomize();

  loglines := TStringList.Create;

finalization

  loglines.Free;

end.
